//Hello1.c
#include <gtk/gtk.h>
G_MODULE_EXPORT void bye_clicked_cb(GtkWidget *widget,gpointer data) {
	gtk_main_quit();
}

G_MODULE_EXPORT void hello_clicked_cb(GtkWidget *widget,gpointer data)
{
	GtkLabel *labeltext=(GtkLabel *)data;
	if(g_strcmp0(gtk_label_get_label(labeltext),"Hello, World!")==0)
	{
		gtk_label_set_label(labeltext,"Very Nice.很好,你的Hello, World!很标准!");
	}
	else 
	{
		gtk_label_set_label(labeltext,"中国人吗?有口音,Hello, World!不标准.");
	}
}

int main(int argc,char *argv[]){
	GtkWidget    *window;
	GtkBuilder *builder;
	GtkLabel    *labeltext;
	GtkWidget *open_dialog;
	//GtkButton   *hellobutton,*byebutton;

	gtk_init(&argc,&argv);
	builder = gtk_builder_new();//创建GtkBuilder对象
	gtk_builder_add_from_file(builder, "testgtk3.glade", NULL);//读取glade文件

	/* create the main, top level, window */
//	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	window = GTK_WIDGET(gtk_builder_get_object(builder, "Mainwindow")); //获取并生成界面对象
	gtk_window_set_title(GTK_WINDOW(window),"Hello World你好世界");
	g_signal_connect(window,"destroy",G_CALLBACK(gtk_main_quit),NULL);

	labeltext = GTK_LABEL(gtk_builder_get_object(builder, "label")); //获取标签构件
	//hellobutton=GTK_BUTTON(gtk_builder_get_object(builder, "hello"));//获取按钮构件
	//g_signal_connect(hellobutton, "clicked", G_CALLBACK(hello_clicked_cb), (gpointer)labeltext);// 将 hello 按钮的 "clicked" 事件与hello_clicked_cb函数关联.
	g_signal_connect(gtk_builder_get_object(builder, "hello"), "clicked", G_CALLBACK(hello_clicked_cb), (gpointer)labeltext);// 直接关联glade文件获取按钮构件[hello]按钮的"clicked" 事件与hello_clicked_cb函数

	//byebutton=GTK_BUTTON(gtk_builder_get_object(builder, "bye"));	
	//g_signal_connect(hellobutton, "clicked", G_CALLBACK(hello_clicked_cb), (gpointer)labeltext);// 将 hello 按钮的 "clicked" 事件与hello_clicked_cb函数关联.	
	//g_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(bye_clicked_cb), NULL);//网上此代码会编译出错
	open_dialog = gtk_file_selection_new("请选择一个文件：");
	g_signal_connect(gtk_builder_get_object(builder, "bye"), "clicked", G_CALLBACK(bye_clicked_cb), NULL);//直接关联glade文件获取按钮构件[bye]按钮的 "clicked" 事件与bye_clicked_cb函数

	g_object_unref(G_OBJECT(builder));// 获取到 UI 对象后，GtkBuilder 对象已没有作用，释放

	gtk_widget_show_all(window);//显示构件


	gtk_main();//进行主循环直到退出

	return 0;
}



